#!/bin/sh
# This file reads the input line $1 (pdb input) and creates the outputs needed
# for generate.inp
#
#
#
#cat $1 |grep -v HOH |grep -v TRS |grep -v " [A-Z][A-Z][+,1-9]" > start.pdb
#cat $1 |grep -v HOH |grep -v TRS |grep -v "CS" |grep -v SO4 > start.pdb
awk '/ALA//ARG//ASN//ASP//CYS//GLN//GLU//GLY//HIS//ILE//LEU//LYS//MET//PHE//PRO//SER//THR//TRP//TYR//VAL/ { print $0} ' $1 > start.pdb
#
############################################
##### LIGANDS: Tris cAMP 		####
############################################
grep "TRS"   $1  > start.ligand.pdb
grep "AMP" $1 >> start.ligand.pdb
#######################
#### START.ION.PDB ####
#######################
awk '/SO4/ {print $0 }' $1 > start.ion.pdb ; printf "TER \n" >> start.ion.pdb
grep  " [A-Z][A-Z][+]" $1  | awk '{printf "%s\nTER \n",$0 }'>> start.ion.pdb
####################################################
#### Waters   sort:column 7 = X , 11 = B-factor ####
####################################################
grep WAT $1   >  start.water.pdb
grep HOH $1 | sort -nk 11 >>  start.water.pdb
#
#grep HOH $1  >>  start.water.pdb
#grep HOH $1 | sort -nk 7  >>  start.water.pdb
#
###################################
##### FIX START.LIGAND.PDB ########
###################################
# This adds TER after the TRS O3 atom (12 copies!)
vi start.ligand.pdb << eof_vi
/O3
A
TER
/O3
A
TER
/O3
A
TER
/O3
A
TER
/O3
A
TER
/O3
A
TER
/O3
A
TER
/O3
A
TER
/O3
A
TER
/O3
A
TER
/O3
A
TER
/O3
A
TER
:wq
eof_vi
################################
##### FIX START.ION.PDB ########
################################
#################################################
##### ADD END statement to start.*.pdb files ####
#################################################
printf "END\nREMARK Created by start.com\n" >> start.pdb
printf "END\nREMARK Created by start.com\n" >> start.ligand.pdb
printf "END\nREMARK Created by start.com\n" >> start.ion.pdb
printf "END\nREMARK Created by start.com\n" >> start.water.pdb
#cat END.PDB >>  start.pdb ; cat END.PDB >>  start.ligand.pdb
#cat END.PDB >>  start.ion.pdb ; cat END.PDB >>  start.water.pdb
#################################################
printf "\n Created start.PDB files from %s" $1
printf " \n vi start.pdb before running cns < generate.inp \n\n"
printf " and remove all TRS CD+ and WAT residues! \n\n"
printf " Add   TER      between monomers. \n\n"
printf " Replace OT1 w/ O and OT2 w/ O,OXT for cns! \n\n"
