#!/bin/sh
echo 'Syntax:'
echo 'pmb_CNS_init  A B C alpha beta gamma "Space_Group" Resolution ' 
echo "Example:"
echo 'create_cns.com 47.59 47.59 62.73 90 90 90 "P4(1)" 1.9'
echo "Notes:"
echo 'Create bindividual, minimize, anneal, rigid, water_pick, '
echo 'and FoFc_calc ...refinement input files'
echo 'Replace bindividual.inp with bindividual_old.inp if you have not recompiled CNS with pmb_bncs.f'
#
#
#if (argc <8) then 
#	exit
#endif
#

$PMB_HOME/create_cns.com bindividual $1 $2 $3 $4 $5 $6 $7 $8
$PMB_HOME/create_cns.com minimize    $1 $2 $3 $4 $5 $6 $7 $8
$PMB_HOME/create_cns.com anneal      $1 $2 $3 $4 $5 $6 $7 $8
$PMB_HOME/create_cns.com bdomain     $1 $2 $3 $4 $5 $6 $7 $8
$PMB_HOME/create_cns.com bvsig       $1 $2 $3 $4 $5 $6 $7 $8
$PMB_HOME/create_cns.com rigid       $1 $2 $3 $4 $5 $6 $7 $8
$PMB_HOME/create_cns.com water_pick  $1 $2 $3 $4 $5 $6 $7 $8
$PMB_HOME/create_cns.com qindividual $1 $2 $3 $4 $5 $6 $7 $8
$PMB_HOME/create_cns.com FoFc_calc   $1 $2 $3 $4 $5 $6 $7 $8
$PMB_HOME/create_cns.com bindividual_old    $1 $2 $3 $4 $5 $6 $7 $8
$PMB_HOME/create_cns.com ncs-shake   $1 $2 $3 $4 $5 $6 $7 $8
$PMB_HOME/create_cns.com omitmap     $1 $2 $3 $4 $5 $6 $7 $8
$PMB_HOME/create_cns.com xtal_pdbsubmission $1 $2 $3 $4 $5 $6 $7 $8
$PMB_HOME/create_cns.com resolve_map $1 $2 $3 $4 $5 $6 $7 $8
$PMB_HOME/create_cns.com pmb_check   $1 $2 $3 $4 $5 $6 $7 $8

#if (-e /sbin/mv) then
#	/sbin/mv resolve_map.inp resolve_map.com;chmod +x *com
#	else
#		/bin/mv resolve_map.inp resolve_map.com;chmod +x *com
#	endif
#endif
mv resolve_map.inp pmb_resolve ;chmod +x *pmb_resolve
mv pmb_check.inp   pmb_check   ;chmod +x *pmb_check
chmod u+rw Fobs.cv
#
# Copy com and generate.inp files here
#
cp $PMB_HOME/CNS/gener*.inp .
cp $PMB_HOME/CNS/NCS.def .
cp $PMB_HOME/CNS/END.PDB .
cp $PMB_HOME/pmb_start   .
cp $PMB_HOME/pmb_cns2phs .
cp $PMB_HOME/pmb_refine  .
touch ligand.param
touch ligand.top
echo '------------------------'
echo 'If you have already run:'
echo ' $PMB_BIN/pmb_sca2cns.exe ScalePack.sca'
echo 'to generate your Fobs.o.cv and Fobs.cv files, then run:'
echo '======================='
echo ' pmb_start {Model.pdb} '
echo '======================='
echo 'to set up your CNS PDB model input files. To refine your model run pmb_refine.pl.'
echo 'First however, edit pmb_refine.pl $PRJ (project name). There are flags which pmb_refine.pl'
echo 'recognizes, use the "-h" flag to get the current list.'
echo '===================================='
echo ' pmb_refine.pl -g |tee {LogFile.log}'
echo '===================================='
echo 'The Ligand.top and Ligand.param files will need to be edited if you have ligands.'
echo 'Replace bindividual.inp with bindividual_old.inp if you have not recompiled CNS with pmb_bncs.f'
