#!/bin/sh
##############################################################################
# Set CCP4 variables for symmetry information and
# for file handling:
#
# SET YOUR CCP4 ENVIRONMENT IN THE SHELL BEFORE RUNNING THIS SCRIPT
#        ccp4_setup ; setenv CCP4_SG 154
##############################################################################
# Use the phases from CNS
##############################################################################
#./pmb_cns2phs.pl fo.sfo.fc.fob

##############################################################################
# Convert LSCALE.PHS file to MTZ
##############################################################################
f2mtz HKLIN pmb_lscale.phs HKLOUT pmb_lscale.mtz << f2mtz_eof |tee f2mtz.html
TITLE   MTZ from PHSS  From FoFc_calc.inp -> pmb_cns2phs.pl
PNAME   D999
DNAME   D999
CELL     80.109   80.109   132.296 90 90 120
LABOUT   H  K  L  FO    FC     PHIC
CTYPout  H  H  H  F     F      P
FORMAT '(2X,3F5.0,3F10.3)'
SYMM $CCP4_SG
f2mtz_eof

##############################################################################
# CCP4 PROCHECK
##############################################################################
procheck minimize.pdb 2.7
##############################################################################
# CCP4 SFCHECK 
##############################################################################
sfcheck << eof
Y
minimize.pdb
pmb_lscale.mtz
F: FO

eof
##############################################################################
echo "Print or view (gv (linux) or xpsview (SGI))the following files"
echo "which contain stereochemical geometry checks and a realspace"
echo "analysis of your model and the electron density."
echo "lpr minimize_0?.ps"
echo "lpr sfcheck_XXXX.ps"
exit
