#!/usr/bin/perl
#LINUX:#!/usr/bin/perl
#SGI:#!/usr/sbin/perl
#####################################################
 # 	CNS AUTOMATED REFINEMENT SCRIPT   v0.2         #
  # 	(C) 2001 MARK A. WHITE, UTMB              #
   # 	Dec 2, 2002                              #
    #############################################

#==============================================================================#
# ENTER THE PROJECT NAME HERE:
#

$PRJ="D999";

#==============================================================================#
# Do not modify code below this line                                           #
#==============================================================================#
#Strip bad characters from project name
#$PRJ~=s/{ ,\@,\\,\/,\~}/_/g;
# COMMAND LINE ARGUMENTS
$waterflag=0;$ncsflag=0;$genflag=0;$rigidflag=0;$omitflag=0;
for($i=0;$i<=$#ARGV;$i++){
    $flags=$ARGV[$i];
    if ($flags=~ /\-w/){($waterflag=$flags)=~ s/\-w//;$waterflag=($waterflag<1)?1:$waterflag;}
    elsif ($flags=~ /\-n/){$ncsflag=1;}
    elsif ($flags=~ /\-g/){$genflag=1;}
    elsif ($flags=~ /\-r/){$rigidflag=1;}
    elsif ($flags=~ /\-a/){$anealflag=1;}
    elsif ($flags=~ /\-o/){$omitflag=1;}
    elsif ($flags=~ /\-q/){$occflag=1;}
    elsif ($flags=~ /\-h/){
	die "\npmb_refine -w3 -g -r -n -q         \n
	FLAGS:
	-w{#}  (pick waters {opt#rounds})	- Default 1 round water pick
	-n     (NCS-shake)		   	- Relaxes NCS restraints
	-r     (Rigid body refinement)		- Normally only used after MR
	-g     (Generate new topology files) 	- Do this after model building 
	-a     (Simulated Annealing) 	     	- Do this if you dare! 
	-o     (Composit Omit Map ) 	     	- Composit omit map 
	-q     (Occupancy refinement) 	     	- qindividual of seleceted atoms! 
	-h     (HELP) - View this message\n\n";}
    }

printf "\n
              ####     #     #      ####
             #    #   # #   # #    #    #
             #    #   #  # #  #    #####
             #####    #   #   #    #    #
             #        #       #    #    #
             #        #       #    #####
#####################################################
 #  CNS AUTOMATED REFINEMENT SCRIPT    v0.3        #
  #     (C) 2001 MARK A. WHITE, UTMB              #
   # 	AUG 2, 2001 - LAST UPDATE DEC 2, 2002    #
    #############################################
\n";
if($waterflag >0)  {printf "WATERFLAG SET - WATERS TO BE ADDED in %d rounds (maximum)\n", $waterflag, $waterflag;}
if($ncsflag >0)    {printf "NCSFLAG SET   - NCS SHAKE/RELAXATION TO BE DONE\n";}
if($genflag >0)    {printf "GENFLAG SET   - A NEW TOPOLOGY FILE WILL BE GENERATED\n";}
if($rigidflag >0)  {printf "RIGIDFLAG SET - RIGID BODY REFINEMENT WILL BE PERFORMED\n";}
if($anealflag >0)  {printf "ANEALFLAG SET - SIMULATED ANNEALING REFINEMENT WILL BE PERFORMED\n";}
if($omitflag >0)   {printf "OMITFLAG SET  - Composit Omit map generated\n";}
if($occflag >0)    {printf "OCCFLAG SET   - OCCUPANCY REFINEMENT WILL BE PERFORMED\n";}
printf "\n";

#
# SET CONSTANTS
#
#LONG DATE stamp:
#system "date +\"%m%d%H%M\" > .tmp ;unalias cp";
system "date +\"%m%d%H\" > .tmp ;unalias cp";
open IN, "< .tmp";
while(<IN>){@date=split(" ", $_);$ID=sprintf"%s_",$date[0];}
close IN;printf "REFINEMENT ID: %s   \tPROJECT: %s \n",$ID,$PRJ;
$STEP=1;

################################################################################
#
# GENERATE NEW TOPOLOGY FILE - IF FLAG SET
#

if ($genflag>0){$prefix=sprintf "$ID.%.2d",0;
system "cns < generate.inp > $prefix.generate.log ;
	grep ERR $prefix.generate.log ;cp -f generate.pdb minimize.pdb ";
	open GIN, "< $prefix.generate.log";my $errorflag=0;
	while (<GIN>){if($_ =~ "ERR"){print $_;$errorflag++ }}
	close GIN;if($errorflag>0){die"ERRORS IN GENERATE - REFINEMENT ABORTED";}
	}
#
if ($rigidflag>0){$prefix=sprintf "$ID.%.2d",$STEP++;
system "cns < rigid.inp    > $prefix.rigid___.log ";}

#
# LOOP THROUGH REFINEMENT UTILL RFREE CONVERGES
#
$Rfree_c=99.0;$Rfree_l=100.0;
while ( $Rfree_c < $Rfree_l ) {
	$Rfree_l=$Rfree_c;$prefix=sprintf "$ID.%.2d",$STEP++;
	system "cns < bindividual.inp > $prefix.bindivid.log ";
	system "cns < minimize.inp    > $prefix.minimize.log ";
	#Get Rfree for this round of refinement
	open IN ,"< minimize.pdb";
	while (<IN>){if($_ =~ " final ") {@line=split(" ",$_);
		$Rfact=$line[3]*100.0;$Rfree_c=$line[5]*100.0;break;}}
		#WHILE IN
	close IN;printf "$ID.%.2d  R-factor=%6.2f   Rfree=%6.2f \n",$STEP-1,$Rfact,$Rfree_c;
	}
	#while Rfree is dropping

#####################
# LOCAL SCALE DATA  #
#####################
system "cns < FoFc_calc.inp > $prefix.zFoFc_cal.log ";
system "./pmb_cns2phs.com   > $prefix.pmb_cns_2phs.log ;
	mv pmb_lscale.phs $prefix.pmb_lscale.phs ;
	cp -f fobs_lscale.fob  Fobs.cv";

#
# OCCUPANCY REFINEMENT
#
if($occflag>0){
	$Rfree_l=$Rfree_c;$prefix=sprintf "$ID.%.2d",$STEP++;
	system "cns < bindividual.inp > $prefix.bindivid.log ";
	system "cns < qindividual.inp > $prefix.qindivid.log ";
	system "cns < bindividual.inp > $prefix.bindivid.log ";
	system "cns < minimize.inp    > $prefix.minimize.log ";
	#Get Rfree for this round of refinement
	open IN ,"< minimize.pdb";
	while (<IN>){if($_ =~ " final ") {@line=split(" ",$_);
		$Rfact=$line[3]*100.0;$Rfree_c=$line[5]*100.0;break;}}
		#WHILE IN
	close IN;printf "$ID.%.2d  R-factor=%6.2f   Rfree=%6.2f  #Occupancy\n",$STEP-1,$Rfact,$Rfree_c;
	}
	# IF ANEALFLAG
#
# NCS SHAKE/RELAXATION ANNEALING
#
if($anealflag>0){
	$Rfree_l=$Rfree_c;$prefix=sprintf "$ID.%.2d",$STEP++;
	system "cns < anneal.inp     > $prefix.anneal_1.log ;cp -f anneal_1.pdb minimize.pdb ";
	#Get Rfree for this round of refinement
	open IN ,"< anneal_1.pdb";
	while (<IN>){if($_ =~ " final ") {@line=split(" ",$_);
		$Rfact=$line[3]*100.0;$Rfree_c=$line[5]*100.0;break;}}
		#WHILE IN
	close IN;printf "$ID.%.2d  R-factor=%6.2f   Rfree=%6.2f  #ANNEAL\n",$STEP-1,$Rfact,$Rfree_c;
	}
	# IF ANEALFLAG

if($ncsflag>0){
	$Rfree_l=$Rfree_c;$prefix=sprintf "$ID.%.2d",$STEP++;
	system "cns < mini-ncs.inp     > $prefix.1min-ncs.log ";
	#Get Rfree for this round of refinement
	open IN ,"< minimize.pdb";
	while (<IN>){if($_ =~ " final ") {@line=split(" ",$_);
		$Rfact=$line[3]*100.0;$Rfree_c=$line[5]*100.0;break;}}
		#WHILE IN
	close IN;printf "$ID.%.2d  R-factor=%6.2f   Rfree=%6.2f  #NCS-shake\n",$STEP-1,$Rfact,$Rfree_c;
#	$Rfree_c=print_rfree($STEP-1,$prefix,"1min-ncs");
	system "cns < bindividual.inp  > $prefix.2bindivi.log ";
	system "cns < minimize.inp     > $prefix.3minimiz.log ";
	#Get Rfree for this round of refinement
	open IN ,"< minimize.pdb";
	while (<IN>){if($_ =~ " final ") {@line=split(" ",$_);
		$Rfact=$line[3]*100.0;$Rfree_c=$line[5]*100.0;break;}}
		#WHILE IN
	close IN;printf "$ID.%.2d  R-factor=%6.2f   Rfree=%6.2f \n",$STEP-1,$Rfact,$Rfree_c;
	}
	# IF NCSFLAG

#
# ADD WATERS
#
$Rfree_l=100;
while($Rfree_c < $Rfree_l && $waterflag-->0){
	$Rfree_l=$Rfree_c;$prefix=sprintf "$ID.%.2d",$STEP++;
	system "cns < water_pick.inp   > $prefix.1wtr_pik.log ";
####	system "cns < water_delete.inp > $prefix.2wtr_del.log;cp -f generate.pdb minimize.pdb ";
	system "cns < bindividual.inp  > $prefix.3bindivi.log ";
	system "cns < minimize.inp     > $prefix.4minimiz.log ";
	#Get Rfree for this round of refinement
	open IN ,"< minimize.pdb";
	while (<IN>){if($_ =~ " final ") {@line=split(" ",$_);
		$Rfact=$line[3]*100.0;$Rfree_c=$line[5]*100.0;break;}}
		#WHILE IN
	close IN;printf "$ID.%.2d  R-factor=%6.2f   Rfree=%6.2f #Water pick\n",$STEP-1,$Rfact,$Rfree_c;
	}
	# WHILE WATERFLAG--
#
# LOOP THROUGH REFINEMENT UTILL RFREE CONVERGES
#
$Rfree_c=99.0;$Rfree_l=100.0;
while ( $Rfree_c < $Rfree_l ) {
	$Rfree_l=$Rfree_c;$prefix=sprintf "$ID.%.2d",$STEP++;
	system "cns < bindividual.inp > $prefix.bindivid.log ";
	system "cns < minimize.inp    > $prefix.minimize.log ";
	#Get Rfree for this round of refinement
	open IN ,"< minimize.pdb";
	while (<IN>){if($_ =~ " final ") {@line=split(" ",$_);
		$Rfact=$line[3]*100.0;$Rfree_c=$line[5]*100.0;break;}}
		#WHILE IN
	close IN;printf "$ID.%.2d  R-factor=%6.2f   Rfree=%6.2f \n",$STEP-1,$Rfact,$Rfree_c;
	}
	#while Rfree is dropping
#####################
# MAKE FINAL MODEL  #
#####################
system "cp -f minimize.pdb   $prefix.$PRJ.pdb   ";

#####################
# LOCAL SCALE DATA  #
#####################
system "cns < FoFc_calc.inp > $prefix.zFoFc_cal.log ";
system "./pmb_cns2phs.com   > $prefix.pmb_cns_2phs.log ;
	cp pmb_lscale.phs $prefix.pmb_lscale.phs ;
	cp -f fobs_lscale.fob  Fobs.cv";

#####################
# GENERATE MAP DATA #
#####################
#system "cns < ncs_average_map.inp > $prefix.zzncs_map.log ";
#system "pmb_ncs2phs.com           > $prefix.pmb_cns_2phs.log ;mv pmb_ncs.phs $prefix.pmb_ncs.phs";
if($omitflag>0){
	$Rfree_l=$Rfree_c;$prefix=sprintf "$ID.%.2d",$STEP++;
	system "cns < omitmap.inp     > $prefix.omitmap.log ";
	}
	# IF NCSFLAG
################################################################################
# Parse refinement data into a summary file $PRJ.sum
################################################################################
#open OUT, ">> $PRJ.sum";
#
#printf "$ID.%.2d  R-factor=%6.2f   Rfree=%6.2f \n",$STEP,$Rfact,$Rfree_c;
#
#close OUT;
#END
