#!/bin/sh
#######################################################################################
# ^R "0102B" "0102B change Model number from A to B
# Examine 119crpA.sum for R-free and R-work statisitics
#######################################################################################

#RUN THIS MANUALLY: inputs: start.pdb
###cns < generate.inp |tee 0102B0.generate.log;grep ERR 0102B0.generate.log;/sbin/cp generate.pdb minimize.pdb
#cns < generate.inp > 0102B0.generate.log
##/sbin/cp generate.pdb minimize.pdb
#
###cns < rigid.inp |tee 0102B0.rigid___.log;grep ERR 0102B0.rigid___.log
#/sbin/cp rigid.pdb minimize.pdb
####/sbin/cp Fobs.o.cv  Fobs.cv
#
###cns < bindividual.inp |tee 0102B02.bindivid.log;grep ERR 0102B02.b*log
#cns < bindividual.inp > 0102B02.bindivid.log
###cns < minimize.inp |tee 0102B02.minimize.log;grep ERR 0102B02.m*log
cns < minimize.inp    > 0102B02.minimize.log
#
cns < bindividual.inp > 0102B03.bindivid.log
cns < minimize.inp    > 0102B03.minimize.log
###########
# ANNEAL  #
###########
#ONLY RUN THIS ONCE - IT SCREWS UP SIDECHAIN ROTOMERS
#
#cns < anneal.inp > 0102B04.anneal__.log
#/sbin/cp anneal_1.pdb minimize.pdb
#
##############
# NCS ANNEAL #
############## 
# DO THIS IF YOU HAVE NCS
#/sbin/cp minimize.pdb bindividual.pdb
#cns < minimize_0ncs.inp   > 0102B05.0ncsmini.log
#/sbin/cp minimize.pdb bindividual.pdb
#cns < minimize_050.inp    > 0102B05.050mini.log
#/sbin/cp minimize.pdb bindividual.pdb
#cns < minimize_300.inp    > 0102B05.300smini.log
###########
# REFINE  #
###########
cns < bindividual.inp > 0102B05.bindivid.log
cns < minimize.inp    > 0102B05.minimize.log
#
cns < bindividual.inp > 0102B06.bindivid.log
cns < minimize.inp    > 0102B06.minimize.log
#
cns < bindividual.inp > 0102B07.bindivid.log
cns < minimize.inp    > 0102B08.minimize.log
#
cns < bindividual.inp > 0102B09.bindivid.log
cns < minimize.inp    > 0102B09.minimize.log
#
cns < bindividual.inp > 0102B10.bindivid.log
cns < minimize.inp    > 0102B10.minimize.log
#
###################
# FoFc and lscale #
###################
/sbin/cp Fobs.o.cv Fobs.cv
cns < FoFc_calc.inp   > 0102B12.FoFc_calc.log
pmb_cns2phs.com ; /sbin/mv pmb_lscale.phs 0102B10.pmb_lscale.phs 
/sbin/cp fobs_lscale.fob Fobs.cv
cns < bindividual.inp > 0102B13.bindivid.log
cns < minimize.inp    > 0102B13.minimize.log
cns < bindividual.inp > 0102B14.bindivid.log
cns < minimize.inp    > 0102B14.minimize.log
#
##############
# WATER PICK #
##############
#DO WATER PICK ONLY AFTER MODEL IS REBUILT & REFINES WELL
cns < water_pick.inp   > 0102B15.1wat_pik.log
cns < water_delete.inp > 0102B15.2wat_del.log
/sbin/cp generate.pdb minimize.pdb
cns < bindividual.inp > 0102B15.bindivid.log
cns < minimize.inp    > 0102B15.minimize.log
#
cns < water_pick.inp   > 0102B16.1wat_pik.log
cns < water_delete.inp > 0102B16.2wat_del.log
/sbin/cp generate.pdb minimize.pdb
cns < bindividual.inp > 0102B16.bindivid.log
cns < minimize.inp    > 0102B16.minimize.log
#
cns < water_pick.inp   > 0102B17.1wat_pik.log
cns < water_delete.inp > 0102B17.2wat_del.log
/sbin/cp generate.pdb minimize.pdb
#
cns < bindividual.inp > 0102B17.bindivid.log
cns < minimize.inp    > 0102B17.minimize.log
cns < bindividual.inp > 0102B18.bindivid.log
cns < minimize.inp    > 0102B18.minimize.log
cns < bindividual.inp > 0102B19.bindivid.log
cns < minimize.inp    > 0102B19.minimize.log
cns < bindividual.inp > 0102B20.bindivid.log
cns < minimize.inp    > 0102B20.minimize.log
cns < bindividual.inp > 0102B21.bindivid.log
cns < minimize.inp    > 0102B21.minimize.log
################################################EDIT THIS
/sbin/cp minimize.pdb   0102B21.CRP-WT.pdb
###########################
# Final MAP + LOCAL SCALE #
###########################
/sbin/cp Fobs.o.cv Fobs.cv
cns < FoFc_calc.inp       > 0102B21.zFoFc_cal.log
pmb_cns2phs.com ; /sbin/mv pmb_lscale.phs 0102B21.pmb_lscale.phs 
/sbin/cp fobs_lscale.fob Fobs.cv
#
###################
# NCS AVERAGED MAP #
#####################
#THIS CREATES A HUGE ASCII MAP - NCS averaged, normally the lscale.phs "MAP" is used
#
#cns < ncs_average_map.inp    > 0102B14.ncs_average_map.log
#pmb_ncs2phs.com
#
#########################################################################################
#Overall R-value for test set:
#########################################################################################
pwd
grep "for working set:" 0102B*log | awk '{printf " %s  \tR-factor=%6.2f \n", $1,100*$7 '} >> 119CRP.log
grep "for test set:"    0102B*log | awk '{printf " %s  \tR-free = %6.2f \n", $1,100*$7 '} >> 119CRP.log
#########################################################################################



