#!/usr/bin/perl
#######################
# pmb_pdb2fasta
#######################
$PDB_IN="minimize.pdb";
$SEQ_OUT="minimize.seq";
$FASTA_OUT="minimize.fasta";
#
open PDB_IN ,"< $PDB_IN";            #Input PDB
open SEQ_OUT ,"> $SEQ_OUT";          #Single Letter AA out
open FASTA_OUT ,"> $FASTA_OUT";      #Single Letter AA out FASTA Format
printf FASTA_OUT "1|PDB XXX|\n";

#######################
#Read Atoms into array
$nnh=0;$na=0;$seq_cnt=0;
while (<PDB_IN>){
if($_ =~ "ATOM ") {
	if($_!~/ H[ ,A-Z,0-9]/){$nnh++;}
	@line=split(" ",$_);
	#  0      1    2   3   4  5        6      7       8      9     10        11 #
	#ATOM   1920  CA  GLU D  55       7.896 -10.299  22.198  1.00 64.99      D
	$atom_name[$na]=$line[2];$atom_aa[$na]=$line[3];
	#  0      1    2   3      4       5       6      7       8      9        10 #
	#ATOM   1920  CA  GLU    55       7.896 -10.299  22.198  1.00 64.99      D
	if($line[4]=~/[A-Z,a-z]/){
		$atom_chain[$na]=$line[4];$atom_resid[$na]=$line[5];
		$atom_x[$na]=$line[6];$atom_y[$na]=$line[7];$atom_z[$na]=$line[8];}
	else{
		$atom_chain[$na]=" ";$atom_resid[$na]=$line[5-1];
		$atom_x[$na]=$line[6-1];$atom_y[$na]=$line[7-1];$atom_z[$na]=$line[8-1];}	
	$na++;
	}
if($_ =~ "SEQRES ") {
	@line=split(" ",$_);  print "$seq_cnt: $line[0] $line[1] $line[2] $line[3] $line[4] $line[5] $line[6] .... $line[14] $line[15] $line[16] \n";
	#  0      1 2  3    4   5   6   7   8   9   10  11  12  13  14  15  16 #
        #SEQRES   1 E  999  GLY SER PRO GLY ILE PRO MET VAL ALA ALA HIS ALA ALA
 	for ($i=4; $i<=16; $i++) {
#        $i=3;while($i++<=16) {
           if( $line[$i]=~/ALA|ARG|ASN|ASP|CYS|GLN|GLU|GLY|HIS|HISH|ILE|LEU|LYS|MET|MSE|PHE|PRO|CPR|SER|THR|TRP|M3L|TYR|VAL/ ){$name_res[$seq_cnt++]=$line[$i];}}  
	#print "$seq_cnt: SEQRES X X NNN $name_res[$seq_cnt-13] $name_res[$seq_cnt-12] $name_res[$seq_cnt-11] .... $name_res[$seq_cnt-3] $name_res[$seq_cnt-2] $name_res[$seq_cnt-1] \n";	
	}
	};close PDB_IN;
printf "Found %d residues in file %s \n",$seq_cnt,$PDB_IN;
#######################
#Output Sequence if SEQRES (Complete Sequence)
for($i=0;$i<$seq_cnt;$i++){
    $name_aa[$i]=SEQ2AA($name_res[$i]);        #print "$i $name_res[$i]=$name_aa[$i] ";
    print SEQ_OUT   $name_aa[$i];
    print FASTA_OUT $name_aa[$i];
    # if($i%10){printf SEQ_OUT " ";printf SEQ_OUT " "; if($i%60){printf SEQ_OUT "\n";printf FASTA_OUT "\n";}}
   }
printf SEQ_OUT "\n";printf FASTA_OUT "\n";
#
close SEQ_OUT;
close FASTA_OUT;
#
exit;
###############################################################################
sub SEQ2AA() {
$residue_name=$_[0]; 
#print " $residue_name ";
$AA_CODE="U";
if($residue_name=~"ALA"){$AA_CODE="A";}
if($residue_name=~"ARG"){$AA_CODE="R";}
if($residue_name=~"ASN"){$AA_CODE="N";}
if($residue_name=~"ASP"){$AA_CODE="D";}
if($residue_name=~"CYS"){$AA_CODE="C";}
if($residue_name=~"GLN"){$AA_CODE="Q";}
if($residue_name=~"GLU"){$AA_CODE="E";}
if($residue_name=~"GLY"){$AA_CODE="G";}
if($residue_name=~"HIS"){$AA_CODE="H";}
if($residue_name=~"HISH"){$AA_CODE="H";}
if($residue_name=~"ILE"){$AA_CODE="I";}
if($residue_name=~"LEU"){$AA_CODE="L";}
if($residue_name=~"LYS"){$AA_CODE="K";}
if($residue_name=~"MET"){$AA_CODE="M";}
if($residue_name=~"MSE"){$AA_CODE="M";}
if($residue_name=~"PHE"){$AA_CODE="F";}
if($residue_name=~"PRO"){$AA_CODE="P";}
if($residue_name=~"CPR"){$AA_CODE="P";}
if($residue_name=~"SER"){$AA_CODE="S";}
if($residue_name=~"THR"){$AA_CODE="T";}
if($residue_name=~"TRP"){$AA_CODE="W";}
if($residue_name=~"M3L"){$AA_CODE="K";}
if($residue_name=~"TYR"){$AA_CODE="Y";}
if($residue_name=~"VAL"){$AA_CODE="V";}
return $AA_CODE;
}
